// Расчет книг через SQL
/*
Расчет книги происходит в 3 шага:

1. Расчет разницы между полной суммой по документу и суммой, которая должна быть
   по первому событию для тех документов, которые попадают в книгу полной суммой.
2. Расчет книги в "чистом" виде. Без учета того, что некоторые документы должны
   попадать в книгу полной суммой.
3. 

*/
include("sys\\dpsql.js");
include("objects\\DpJRegistrator.js");

function jr_(jID, sExpr)
{
	var fdoc;
	var fwid;
	
	if (this.getJDoc() != null)
	{
		fdoc = this.getJDoc().getVar("HDOC");
		fwid = this.getJDoc().getVar("HID");
	}
	else
	{
		fdoc = this.getTable().getValue("fdoc"),
		fwid = this.getTable().getValue("fwid");
	}
	var uRet = 0;
	
	
	var journal = getJournal(jID);
		
	if(journal == null)
	{
		WAIT("У документа нет записи по схеме регистрации " + jID);
		return uRet;
	}

	jID = journal.Num;
	
	var sTbl = journal.getFullTableName();
	var tblDocreg = OpenTable("s"
		, " SELECT *"
		+ " FROM " + sTbl
		+ " WHERE HID_DOC=" + sqlTo(fwid)
			+ " AND HREG=" + sqlTo(jID)
		);
	if (tblDocreg.IsEmpty())
		WAIT("У документа нет записи по схеме регистрации "+jID);
	else
		uRet = jr_value(jID, sExpr, tblDocreg);
	tblDocreg.close();
	return uRet;
}

function jr_value(jID, sExpr, tReg)
{
	sExpr = " " + sExpr + " ";

	sExpr = sExpr.replace(/(\W)v0(\w+)/gi, "$1getV0('" + jID + "','$2',tReg)");
	sExpr = sExpr.replace(/(\W)v1(\w+)/gi, "$1getV1('" + jID + "','$2',tReg)");
	sExpr = sExpr.replace(/(\W)v2(\w+)/gi, "$1getV2('" + jID + "','$2',tReg)");

	sExpr = sExpr.trim();	
	return eval(sExpr);
}

function getV1(jID, cVar, tReg)
{
	if(toScrObj(tReg.getValue("HISNOV1")))
	{
		return 0;
	}
	else
		return getV2(jID, cVar, tReg);
}

var getV2_oVars;
var getV2_oTypeVars;

var getV2_fwid, getV2_cTbl;

function getV2(jID, cVar, tReg)
{
	curFwid = tReg.getValue("fwid");
		
	//if(curFwid!=getV2_fwid) - из-за кэша неправильно расчитывалось первое событие для некоторых переменных
	{
		oCond = new Object;
		oCond.freg = jID;
		oCond.fwid = tReg.getValue("fwid")
//-		oCond.fsort = tReg.getValue("fsort")			fsort ???
		getV2_cTbl = calcBook(jrvid(jID)
			, oCond
			, cVar);
		getV2_fwid = curFwid;
	}
	
	var oSnap = getSnap("SELECT V2" + cVar
					+ " FROM " + getV2_cTbl);
					
	return oSnap == null?0:oSnap[0];
}

function getV0(jID, cVar, tReg)
{
	curFwid = tReg.getValue("fwid");
	
	if (cVar == "DCTSUM")
	{
		if (jrvid(jID)=="-")
		{
			sSNds = getV0("HTPOSNDS") - getV0("HTVOSNDS");
				
			return getV0("HTPO20") - Math.abs(getV0("HTVO20"))
				+ (sSNds - round(sSNds/6, 2))
		}
	}
	else if (cVar == "SUMNDS")
	{
		if (jrvid(jID)=="-")
		{
			sSNds = getV0("HDPOSNDS") - getV0("HDVOSNDS");
				+ getV0("HTPOSNDS") - getV0("HTVOSNDS");
			
			return getV0("HDPONDS") - Math.abs(getV0("HDVONDS"))
				+ getV0("HTPONDS") - Math.abs(getV0("HTVONDS"))
				+ round(sSNds/6, 2)
		} 
	}
	
	if(curFwid!=getV2_fwid)
	{
		oCond = new Object;
		oCond.freg = jID;
		oCond.fwid = tReg.getValue("fwid")
//-		oCond.fsort = tReg.getValue("fsort")			fsort ???
		getV2_cTbl = calcBook(jrvid(jID)
			, oCond
			, cVar);
		getV2_fwid = curFwid;
	}
	
	var oSnap = getSnap("SELECT " + cVar
					+ " FROM " + getV2_cTbl);
					
	return oSnap == null?0:oSnap[0];
}

function calcBook(vid, oCond, cParVar)
{
	var calcProc = getPar(vid=="-"? "PR_CALCPROC": "POK_CALCPROC");
	
	if (calcProc=="LOOP")
		return calcBookLoop(vid, oCond, cParVar);
	else
		return calcBookSQL(vid, oCond, cParVar);
}

function calcBookLoop(vid, oCond, cParVar)
{
	cParVar = cParVar? cParVar.toUpperCase(): "";

	jReg = getRegistrator();
	var cCond = "";

	if(oCond.fwid)
	{
		cCond += " AND a.hreg=" + sqlTo(oCond.freg)
				+ " AND a.fwid=" + sqlTo(oCond.fwid)
	}
	
	var cWhereSuffix = "";
	
	var joinCond = "";
	if(oCond.fbdat)
	{
		cCond = " AND (( a.hnkdat<=" + sqlTo(oCond.fedat)
				+ " AND a.hnkdat>=" + sqlTo(oCond.fbdat)
			+ ") OR (a.hnkdat=" + sqlTo(d00)
				+ " AND a.hdat BETWEEN " + sqlTo(oCond.fbdat) + " AND " + sqlTo(oCond.fedat)
			+ "))"
		
		// Добавляем условие по номеру журнала регистрации
		if(oCond.freg)
		{
			cCond += " AND a.hreg=" + sqlTo(oCond.freg);
		}
			
		// Добавляем условие по виду регистрации
		if(oCond.fvid)
		{
			// Отберем все журналы указанного вида
			var jList = jReg.listJournals(false);
			cVidCond = "";
			for (var jID in jList)
				if (strIn((vid == "+"?"P":"M"),jList[jID].getType()))
					cVidCond += (cVidCond? ",": "") + sqlTo(jID);
			cWhereSuffix = " AND a.hreg IN (" + cVidCond + ")"
		}
		

		if (vid == "-")
		{
			oSld = getSnap(
				"SELECT MAX(fdoc_dat)"
				+ " FROM ^hsldregm"
				+ " WHERE fdoc_dat<=" + sqlTo(oCond.fbdat)
				)
			
			if (oSld[0])
			{
				joinCond += " AND b.hdat>=" + sqlTo(oSld[0])
			}
			
		}
		
	}
	else if (oCond.fwid)
	{
		if (vid == "-")
		{
			oSld = getSnap(
				"SELECT MAX(fdoc_dat)"
				+ " FROM ^hsldregm"
				+ " WHERE fdoc_dat<=(SELECT hdat FROM ^mdocreg WHERE fwid="+sqlTo(oCond.fwid)+")"
				)
			
			if (oSld[0])
			{
				joinCond += " AND b.hdat>=" + sqlTo(oSld[0])
			}
		}
	}
	

	getV2_oVars = new Object();
	getV2_oTypeVars = new Object();
	getV2_oTypeVars["-"] = new Object();
	getV2_oTypeVars["+"] = new Object();
	
	var jList = jReg.listJournals();
	var jVarList = null;
	//- чтобы получить список переменных журналов для вида (+/-)
	//- достаточно получить список переменных одного из журналов
	//- все переменные одинаковые для журналов одного вида
	for (var jID in jList)
	{
		if (jVarList != null)
			break;
		if (strIn((vid == "+"?"P":"M"),jList[jID].getType()))
		{
			jVarList = jList[jID].getFieldsImpl();
		}
	}
	
	var exprV1DCNDS = "";
	var exprV1DCNDSV = "";
	var exprV1DCSUM = "";
	var exprV1DCSUMV = "";

	var oAttrs = new Object();
	
	// Пройдем по переменным, участвующим в расчете книги
	for (var nVar = 0; nVar < jVarList.length; nVar++)
	{
		var cVar = jVarList[nVar].FVAR;
		var cAttr = jVarList[nVar].FATTR;
		if (!/H[TD][PV]/.test(cVar))
			continue;
		var cOp = cVar.substr(2,1);
		
		oAttrs[cVar] = cAttr;
		
		getV2_oTypeVars[vid][cVar] = cVar;
		getV2_oVars[cVar] = cVar;
	}
	
	var sqlB0 = "";
	var sqlV0 = "";
	var sqlS0 = ""
	var sqlDelta = "";
	var sqlD0Fields = "";
	var sqlD0Values = "";
	
	sqlFlds = "";
	sqlV0Flds = "";
	sqlBook = "";
	sqlBookFields = "";
	sqlDeltaChange = "";
	sqlDeltaXFields = "";
	sqlV2Fields = "";
	sqlHaving = "";
	
	cAllS = new Object();
	
	sqlBook4Create = "";
	sqlFields4Select = "";
	
	for(cV in getV2_oTypeVars[vid])
	{
		cField = getV2_oTypeVars[vid][cV];
		cAField = "a." + cField;
		cBField = "b." + cField;
		
		if(cV.substr(2,1)=="V")
		{
			cAField = "abs(" + cAField + ")"
			cBField = "abs(" + cBField + ")"
		}

		
		sqlS0 += (sqlS0? ",": "") + "SUM(" + cBField + ")"
			+ " AS S0" + cV;
		
		sqlV0 += "," + cAField + " AS V0" + cV;
		sqlV0Flds += ",V0" + cV;
		sqlBook4Create += ", V0" + cV + " " + SqlType("currency");
		sqlFields4Select += ", V0" + cV;
		
		sqlFlds += ",a." + cField;
		
		var cSumD = "SUM(D" + cV + ")"
		cSumD = sqlIIF(cSumD + " IS NULL",0,cSumD)
		
		sqlBook += ", 0.0 AS V2" + cV;
		sqlBook4Create += ",V2"+ cV + " " + SqlType("currency");
		
		sqlBookFields += ",V2"+ cV;
		/*
		var sumBookVar = sqlSumBookVar(cV);
		
		sqlBook += "," + sumBookVar + " AS V2" + cV;
		*/
		
		cV2value = "a.V2" + cV + "-" + cSumD
		
		sqlDeltaXFields += ",a.V2" + cV + "-" + cSumD + " AS V2_" + cV
		
		cV2value = sqlIIF("Sgn(a.V2" + cV + ")*Sgn(V2_" + cV + ")<0", 0," V2_" + cV);
//-		cV2value = "iif(Abs(first(a.V0" + cV + "))<Abs(V2_" + cV + "), first(a.V0" + cV + "), " + cV2value + ")"
		cV2value = sqlIIF("Abs(min(a.V0" + cV + "))<Abs(V2_" + cV + ")"," min(a.V0" + cV + ")", cV2value);
		
		sqlV2Fields += ", a.V2" + cV
		sqlHaving += " OR " + sqlRound("V2" + cV,2) + "<>0"
		
		sqlD0Fields += "," + "D" + cV;
		sqlD0Values += ",0";
		
		cAllS[cV.substr(3)] = ""

		cAttr = oAttrs[cV];
		cOp = cV.substr(2,1);
		
		/*
		if (true)
		{		
			if(strIn("N", cAttr) && (cOp=="P" || cOp=="V"))
			{
				exprV1DCNDS += "+" + sumBookVar;
				if(cOp=="P")
					exprV1DCNDSV += "+" + sumBookVar;
				else
					exprV1DCNDSV += "-" + sumBookVar;
				isDcOnly = true;
			}
			else if((strIn("O", cAttr) || strIn("B", cAttr)) 
					&& (cOp=="P" || cOp=="V"))
			{
				exprV1DCSUM += "+" + sumBookVar;
				if(cOp=="P")
					exprV1DCSUMV += "+" + sumBookVar;
				else
					exprV1DCSUMV += "-" + sumBookVar;
				isNdsOnly = true;
			}
		}
		*/
	}
	// Формирование полной суммы (покупки - возврат - (продажа - возврат))
	sqlA = "";
	var sDocregTbl = "^" + (vid == "+"?"P":"M") + "DOCREG";

	for(cSuffix in cAllS)
	{
		cAllS[cSuffix] = "SUM(b." + getV2_oVars["HDP" + cSuffix]
			+ "-abs(b." + getV2_oVars["HDV" + cSuffix]+")"
			+ "-b." + getV2_oVars["HTP" + cSuffix]
			+ "+abs(b." + getV2_oVars["HTV" + cSuffix]+")"
			+ ")"
		sqlA += "," + cAllS[cSuffix] + " AS A0" + cSuffix
	}

	DropTable("tmp_regxp_book");

	var cExtFields = "";
	
	if(cParVar.toUpperCase()=="DCSUM" || cParVar.toUpperCase()=="DCNDS")
	{
		cExtFields = "," + exprV1DCSUM.substr(1) + " AS v2dcsum";
		cExtFields += "," + exprV1DCNDS.substr(1) + " AS v2dcnds";
		
		sqlBook4Create += ", v2dcsum " + SqlType("currency")	
			+ ", v2dcnds " + SqlType("currency")
		sqlFields4Select += ", v2dcsum, v2dcnds";
	}

//-	gray придётся так поступить - потому, что не всегда в строках регистрации проставлены HNKNOM & HNKDAT
//-	поэтому JOIN и суммирование и группировка - не сработают
// DAE - закоментировали, т.к. эти 3 запроса занимали 1 секунду времени.
	/*
	var tmpCond = cCond;
	tmpCond = tmpCond.replace(/a\./g,"");
	ExecuteSQL("UPDATE " + sDocregTbl
			 + " SET HNKNOM=" + sqlTo("")
			 + " WHERE HNKNOM IS NULL "
			 + tmpCond
			   );

	ExecuteSQL("UPDATE " + sDocregTbl
			 + " SET HNKDAT=" + sqlTo(new Date("01/01/3000"))
			 + " WHERE HNKDAT IS NULL "
			 + tmpCond
			   );
	ExecuteSQL("UPDATE " + sDocregTbl
			 + " SET HSORT=" + sqlTo(0)
			 + " WHERE HSORT IS NULL "
			 + tmpCond
			  );
	*/
//- gray end

	var fieldJoinDog = "", joinOnDog = "";

	/* связь делаем только по hiddeal, 
	switch(getPar("PR_DOGREG"))
	{
	case "-":
		break;
	case "*":
		fieldJoinDog = ",a.hgroup";
		joinOnDog = " AND a.hgroup=b.hgroup"
		break;
	case "+":
		fieldJoinDog = ",a.HIDCONTR";
		joinOnDog = " AND a.HIDCONTR=b.HIDCONTR"
		break;
	}
	*/

	ExecuteSQL(
		"CREATE TABLE tmp_regxp_book ("
			+ "fwid " + sqlType("INT")
			+ ", hdat " + sqlType("DATE")
			+ ", hid_doc " + sqlType("INT")
			+ ", hreg " + sqlType("TEXT")
			+ ", horg " + sqlType("INT")
			+ ", hiddeal " + sqlType("INT")
			+ ", hnknom " + sqlType("TEXT")
			+ ", hnkdat " + sqlType("DATE")
			+ ", hful " + sqlType("INT")
			+ ", hiscor " + sqlType("INT")
			+ ", HVID_DOC " + sqlType("TEXT")
			+ ", HSORT" + sqlType("INT")
			+ ", hopform" + sqlType("TEXT")
			+ sqlBook4Create
			+ ")"
		)

	sql = "INSERT INTO tmp_regxp_book" 
		+ "(fwid, hdat, hid_doc, hreg, horg, hiddeal, hnknom, hnkdat, hful, hiscor, HVID_DOC, HSORT, hopform"
			+ sqlBookFields
			+ sqlFields4Select + ")"
		+ " SELECT a.fwid, a.hdat, a.hid_doc, a.hreg, a.horg, a.hiddeal"// + fieldJoinDog
			+ ", a.hnknom, a.hnkdat, a.hful, a.hiscor, a.HVID_DOC"
			+ ", a.HSORT"
			+ " ,a.hopform"
			//+ sqlA
			+ sqlBook
			+ sqlV0
			+ cExtFields
		+ " FROM " + sDocregTbl + " AS a"
		+ " WHERE a.hdoc<>'SLDREGM' " // "not a.fisnov1" - условие по наличии налоговой проверяется не тут
			+ cCond
			+ cWhereSuffix

	ExecuteSQL(sql);

	
	tBook = OpenTable("tmp_regxp_book")
	
	BeginTransaction(4);
	
	var nRows = tBook.rowCount;
	setProgressRange(1, tBook.rowCount);
	nRow = 0;
	
	for(; !tBook.IsEOF(); tBook.MoveNext())
	{
		nRow++;
		if (nRow % 5 == 0)
			setProgressPos(nRow + 1, "Обработка документов: "+ nRow+"/"+nRows);
		var tSum = OpenTable(
			"SELECT " + sqlS0
			+ " FROM " + sDocregTbl + " AS b"
			+ " WHERE b.hiddeal=" + sqlTo(tBook.getValue("hiddeal"))
			+ " AND b.horg=" + sqlTo(tBook.getValue("horg"))
			+ " AND b.hiddeal=" + sqlTo(tBook.getValue("hiddeal")) 
			+ " AND (" + sqlCmpVectorsEx(
				"<=" , "b.hdat", sqlTo(tBook.getValue("hdat"))
				//, ">=", "b.fisnov1", "a.fisnov1"
				//, ">=", "b.hnknom", "a.hnknom"	//в MySQL изза этой фигни появляются левые накладные с нулевым номером (ЧЕРЕДА в шоке!).
				//, "<=", "b.hnkdat", "a.hnkdat"
				, "<=", "b.hsort", sqlTo(tBook.getValue("hsort"))
				, "<", "b.hid_doc", sqlTo(tBook.getValue("hid_doc"))
				) + ")"
			+ joinCond
			)

		var sqlVars = "";
		for(cV in getV2_oTypeVars[vid])
		{
			var value = Number(getBookVarValue(cV, tBook, tSum));

			if (sqlVars)
				sqlVars += ",";
			sqlVars += "V2" + cV + "=" + sqlTo(value);
		}
		ExecuteSQL(
			"UPDATE tmp_regxp_book"
			+ " SET " + sqlVars
			+ " WHERE fwid=" + sqlTo(tBook.getValue("fwid"))
			);
		
		tSum.Close();			
			
	}
	CommitTrans();	
	
	setProgressPos(0,"");
	
	//browse("tmp_regxp_book")
	
	/*
	ExecuteSQL(
		"DELETE FROM tmp_regxp_book"
		+ " WHERE not (1<>1" + sqlHaving + ")"
		);
	*/
		
	return "tmp_regxp_book";
}

function calcBookSQL(vid, oCond, cParVar)
{
	cParVar = cParVar? cParVar.toUpperCase(): "";

	jReg = getRegistrator();
	var cCond = "";

	if(oCond.fwid)
	{
		cCond += " AND a.hreg=" + sqlTo(oCond.freg)
				+ " AND a.fwid=" + sqlTo(oCond.fwid)
	}
	
	var cWhereSuffix = "";
	
	var joinCond = "";
	if(oCond.fbdat)
	{
		cCond = " AND (( a.hnkdat<=" + sqlTo(oCond.fedat)
				+ " AND a.hnkdat>=" + sqlTo(oCond.fbdat)
			+ ") OR (a.hnkdat=" + sqlTo(d00)
				+ " AND a.hdat BETWEEN " + sqlTo(oCond.fbdat) + " AND " + sqlTo(oCond.fedat)
			+ "))"
		
		// Добавляем условие по номеру журнала регистрации
		if(oCond.freg)
		{
			cCond += " AND a.hreg=" + sqlTo(oCond.freg);
		}
			
		// Добавляем условие по виду регистрации
		if(oCond.fvid)
		{
			// Отберем все журналы указанного вида
			var jList = jReg.listJournals(false);
			cVidCond = "";
			for (var jID in jList)
				if (strIn((vid == "+"?"P":"M"),jList[jID].getType()))
					cVidCond += (cVidCond? ",": "") + sqlTo(jID);
			cWhereSuffix = " AND a.hreg IN (" + cVidCond + ")"
		}
		

		if (vid == "-")
		{
			oSld = getSnap(
				"SELECT MAX(fdoc_dat)"
				+ " FROM ^hsldregm"
				+ " WHERE fdoc_dat<=" + sqlTo(oCond.fbdat)
				)
			
			if (oSld[0])
			{
				joinCond += " AND b.hdat>=" + sqlTo(oSld[0])
			}
			
		}
		
	}
	else if (oCond.fwid)
	{
		if (vid == "-")
		{
			oSld = getSnap(
				"SELECT MAX(fdoc_dat)"
				+ " FROM ^hsldregm"
				+ " WHERE fdoc_dat<=(SELECT hdat FROM ^mdocreg WHERE fwid="+sqlTo(oCond.fwid)+")"
				)
			
			if (oSld[0])
			{
				joinCond += " AND b.hdat>=" + sqlTo(oSld[0])
			}
		}
	}
	

	getV2_oVars = new Object();
	getV2_oTypeVars = new Object();
	getV2_oTypeVars["-"] = new Object();
	getV2_oTypeVars["+"] = new Object();
	
	var jList = jReg.listJournals();
	var jVarList = null;
	//- чтобы получить список переменных журналов для вида (+/-)
	//- достаточно получить список переменных одного из журналов
	//- все переменные одинаковые для журналов одного вида
	for (var jID in jList)
	{
		if (jVarList != null)
			break;
		if (strIn((vid == "+"?"P":"M"),jList[jID].getType()))
		{
			jVarList = jList[jID].getFieldsImpl();
		}
	}
	
	var exprV1DCNDS = "";
	var exprV1DCNDSV = "";
	var exprV1DCSUM = "";
	var exprV1DCSUMV = "";

	var oAttrs = new Object();
	
	// Пройдем по переменным, участвующим в расчете книги
	for (var nVar = 0; nVar < jVarList.length; nVar++)
	{
		var cVar = jVarList[nVar].FVAR;
		var cAttr = jVarList[nVar].FATTR;
		if (!/H[TD][PV]/.test(cVar))
			continue;
		var cOp = cVar.substr(2,1);
		
		oAttrs[cVar] = cAttr;
		
		getV2_oTypeVars[vid][cVar] = cVar;
		getV2_oVars[cVar] = cVar;
	}
	
	var sqlB0 = "";
	var sqlV0 = "";
	var sqlS0 = ""
	var sqlDelta = "";
	var sqlD0Fields = "";
	var sqlD0Values = "";
	
	sqlFlds = "";
	sqlV0Flds = "";
	sqlBook = "";
	sqlDeltaChange = "";
	sqlDeltaXFields = "";
	sqlV2Fields = "";
	sqlHaving = "";
	
	cAllS = new Object();
	
	for(cV in getV2_oTypeVars[vid])
	{
		cField = getV2_oTypeVars[vid][cV];
		cAField = "a." + cField;
		cBField = "b." + cField;
		
		if(cV.substr(2,1)=="V")
		{
			cAField = "abs(" + cAField + ")"
			cBField = "abs(" + cBField + ")"
		}

		sqlS0 += (sqlS0? ",": "") + "SUM(" + cBField + ")"
			+ " AS S0" + cV;
		sqlV0 += "," + cAField + " AS V0" + cV;
		sqlV0Flds += ",V0" + cV;
		
		sqlFlds += ",a." + cField;
		
		var cSumD = "SUM(D" + cV + ")"
		cSumD = sqlIIF(cSumD + " IS NULL",0,cSumD)
		
		var sumBookVar = sqlSumBookVar(cV);
		
		sqlBook += "," + sumBookVar + " AS V2" + cV;
		
		cV2value = "a.V2" + cV + "-" + cSumD
		
		sqlDeltaXFields += ",a.V2" + cV + "-" + cSumD + " AS V2_" + cV
		
		cV2value = sqlIIF("Sgn(a.V2" + cV + ")*Sgn(V2_" + cV + ")<0", 0," V2_" + cV);
//-		cV2value = "iif(Abs(first(a.V0" + cV + "))<Abs(V2_" + cV + "), first(a.V0" + cV + "), " + cV2value + ")"
		cV2value = sqlIIF("Abs(min(a.V0" + cV + "))<Abs(V2_" + cV + ")"," min(a.V0" + cV + ")", cV2value);
		
		sqlV2Fields += ", a.V2" + cV
		sqlHaving += " OR " + sqlRound("V2" + cV,2) + "<>0"
		
		sqlD0Fields += "," + "D" + cV;
		sqlD0Values += ",0";
		
		cAllS[cV.substr(3)] = ""

		cAttr = oAttrs[cV];
		cOp = cV.substr(2,1);
		
		if (true)
		{		
			if (cField=="HTPOSNDS" || cField=="HDPOSNDS" || cField=="HTVOSNDS" || cField=="HDVOSNDS")
			{
				exprV1DCNDS += "+" + sqlRound(sumBookVar + "/6", 2);
				exprV1DCSUM += "+ (" + sumBookVar + "-" + sqlRound(sumBookVar + "/6", 2) + ")";
				isDcOnly = true;
			}
			else if(strIn("N", cAttr) && (cOp=="P" || cOp=="V"))
			{
				exprV1DCNDS += "+" + sumBookVar;
				if(cOp=="P")
					exprV1DCNDSV += "+" + sumBookVar;
				else
					exprV1DCNDSV += "-" + sumBookVar;
				isDcOnly = true;
			}
			else if((strIn("O", cAttr) || strIn("B", cAttr)) 
					&& (cOp=="P" || cOp=="V"))
			{
				exprV1DCSUM += "+" + sumBookVar;
				if(cOp=="P")
					exprV1DCSUMV += "+" + sumBookVar;
				else
					exprV1DCSUMV += "-" + sumBookVar;
				isNdsOnly = true;
			}
		}
	}
	// Формирование полной суммы (покупки - возврат - (продажа - возврат))
	sqlA = "";
	var sDocregTbl = "^" + (vid == "+"?"P":"M") + "DOCREG";

	for(cSuffix in cAllS)
	{
		cAllS[cSuffix] = "SUM(b." + getV2_oVars["HDP" + cSuffix]
			+ "-abs(b." + getV2_oVars["HDV" + cSuffix]+")"
			+ "-b." + getV2_oVars["HTP" + cSuffix]
			+ "+abs(b." + getV2_oVars["HTV" + cSuffix]+")"
			+ ")"
		sqlA += "," + cAllS[cSuffix] + " AS A0" + cSuffix
	}

	DropTable("tmp_regxp_book");

	var cExtFields = "";
	
	if(cParVar.toUpperCase()=="DCSUM" || cParVar.toUpperCase()=="DCNDS")
	{
		cExtFields = "," + exprV1DCSUM.substr(1) + " AS v2dcsum";
		cExtFields += "," + exprV1DCNDS.substr(1) + " AS v2dcnds";
	}

//-	gray придётся так поступить - потому, что не всегда в строках регистрации проставлены HNKNOM & HNKDAT
//-	поэтому JOIN и суммирование и группировка - не сработают
// DAE - закоментировали, т.к. эти 3 запроса занимали 1 секунду времени.
	/*
	var tmpCond = cCond;
	tmpCond = tmpCond.replace(/a\./g,"");
	ExecuteSQL("UPDATE " + sDocregTbl
			 + " SET HNKNOM=" + sqlTo("")
			 + " WHERE HNKNOM IS NULL "
			 + tmpCond
			   );

	ExecuteSQL("UPDATE " + sDocregTbl
			 + " SET HNKDAT=" + sqlTo(new Date("01/01/3000"))
			 + " WHERE HNKDAT IS NULL "
			 + tmpCond
			   );
	ExecuteSQL("UPDATE " + sDocregTbl
			 + " SET HSORT=" + sqlTo(0)
			 + " WHERE HSORT IS NULL "
			 + tmpCond
			  );
	*/
//- gray end

	var fieldJoinDog = "", joinOnDog = "";

	/* связь делаем только по hiddeal, 
	switch(getPar("PR_DOGREG"))
	{
	case "-":
		break;
	case "*":
		fieldJoinDog = ",a.hgroup";
		joinOnDog = " AND a.hgroup=b.hgroup"
		break;
	case "+":
		fieldJoinDog = ",a.HIDCONTR";
		joinOnDog = " AND a.HIDCONTR=b.HIDCONTR"
		break;
	}
	*/


	sql = "SELECT a.fwid, a.hid_doc, a.hreg, a.horg, a.hiddeal" + fieldJoinDog
			+ ", a.hnknom, a.hnkdat, a.hful, a.hiscor, a.HVID_DOC"
			+ ", a.HSORT"
			+ " ,min(a.hopform) AS hopform"
			+ sqlA
			+ sqlBook
			+ sqlV0
			+ cExtFields
		+ " INTO tmp_regxp_book"
		+ " FROM (" + sDocregTbl + " AS a"
			+ " LEFT JOIN " + sDocregTbl + " AS b"
				+ " ON a.hiddeal=b.hiddeal"
					+ " AND a.horg=b.horg"
					+ joinOnDog 
					+ " AND (" + sqlCmpVectorsEx(
						"<=" , "b.hdat", "a.hdat"
						//, ">=", "b.fisnov1", "a.fisnov1"
						//, ">=", "b.hnknom", "a.hnknom"	//в MySQL изза этой фигни появляются левые накладные с нулевым номером (ЧЕРЕДА в шоке!).
						//, "<=", "b.hnkdat", "a.hnkdat"
						, "<=", "b.hsort", "a.hsort"
						, "<", "b.hid_doc", "a.hid_doc"
						) + ")"
					+ joinCond
		+ ")"
		+ " WHERE a.hdoc<>'SLDREGM' " // "not a.fisnov1" - условие по наличии налоговой проверяется не тут
			+ cCond
			+ cWhereSuffix
		+ " GROUP BY a.fwid, a.hid_doc,a.hsort, a.hreg, a.horg, a.hiddeal" + fieldJoinDog
			//+ ",a.freg,a.fdoc,a.fnop,a.fid_doc,a.fdoc_dat,a.forg,a.fnk_dat,a.fnk_num" // ",a.fop_form,a.fpr_cond"
			+ ", a.hnknom, a.hnkdat, a.hful, a.hiscor, a.HVID_DOC"
			+ sqlFlds
	

	ExecuteSQL(sql);
	
	/*
	ExecuteSQL(
		"DELETE FROM tmp_regxp_book"
		+ " WHERE not (1<>1" + sqlHaving + ")"
		);
	*/
		
	return "tmp_regxp_book";
}

// Функция для получения sql-выражения по переменной, как данная 
// переменная попадает в книгу
function getBookVarValue(cVar, tBook, tSums)
{
	var cTD = cVar.charAt(1);
	var cPV = cVar.charAt(2);
	var cSuffix = cVar.substr(3);
	
	cTP = getV2_oVars["HTP" + cSuffix];
	cTV = getV2_oVars["HTV" + cSuffix];
	cDP = getV2_oVars["HDP" + cSuffix];
	cDV = getV2_oVars["HDV" + cSuffix];
	
	a0Expr =  "SUM(b." + getV2_oVars["HDP" + cSuffix]
                 			+ "+b." + getV2_oVars["HDV" + cSuffix]
	                     			+ "-b." + getV2_oVars["HTP" + cSuffix]
	                     			+ "-b." + getV2_oVars["HTV" + cSuffix]
	                     			+ ")";
	var a0Sum = Number(tSums.getValue("S0HDP" + cSuffix))
		+ Number(tSums.getValue("S0HDV" + cSuffix))
		- Number(tSums.getValue("S0HTP" + cSuffix))
		- Number(tSums.getValue("S0HTV" + cSuffix))
	                     			
	var v0Sum = Number(tBook.getValue("V0" + cVar));
		
	/*
	if (Boolean(tBook.getValue("hful")))             		
	{
		return v0Sum;
	}
	*/
	                  
  	switch(cTD + cPV)
	{
	case "TP":
		return Math.max(0, v0Sum - Math.max(0, a0Sum));
	case "DP":
		return Math.max(0, v0Sum - Math.max(0, -a0Sum));
	case "TV":
		return -Math.min(Math.abs(v0Sum), Math.max(0, -a0Sum));
		/*
		sSQL = IIF("a.hful<>0"
			, "- abs(a." + getV2_oVars["HTV" + cSuffix] + ")"
			, "-" + sqlMin( " abs(a." + getV2_oVars["HTV" + cSuffix] + ")"
				, sqlMax0(
					"-" + a0Expr
					)
				)
			)
		break;
		*/
	case "DV":
		return -Math.min(Math.abs(v0Sum), Math.max(0, a0Sum));
		/*
		sSQL = IIF("a.hful<>0"
			, "-abs(a." + getV2_oVars["HDV" + cSuffix]+")"
 			, "-" + sqlMin( " abs(a." + getV2_oVars["HDV" + cSuffix]+")"
				, sqlMax0(
					a0Expr
					)
				)
			)
		break;
		*/
	}
}


function sqlSumBookVar(cVar)
{
	var cTD = cVar.charAt(1);
	var cPV = cVar.charAt(2);
	var cSuffix = cVar.substr(3);
	
	cTP = getV2_oVars["HTP" + cSuffix]
	cTV = getV2_oVars["HTV" + cSuffix]
	cDP = getV2_oVars["HDP" + cSuffix]
	cDV = getV2_oVars["HDV" + cSuffix]
	
	cS0TP = "S0" + cTP;
	cS0TV = "S0" + cTV;
	cS0DP = "S0" + cDP;
	cS0DV = "S0" + cDV;
	

//-	if(false)
	if (true)
	{
	a0Expr =  "SUM(b." + getV2_oVars["HDP" + cSuffix]
			+ "+b." + getV2_oVars["HDV" + cSuffix]
			+ "-b." + getV2_oVars["HTP" + cSuffix]
			+ "-b." + getV2_oVars["HTV" + cSuffix]
			+ ")"
	}
	else
	{
	a0Expr = "A0" + cSuffix;
	}

	switch(cTD + cPV)
	{
	case "TP":
		sSQL = IIF("a.hful<>0"
				, "a." + cTP
					, sqlMax(0
					, "a." + getV2_oVars["HTP" + cSuffix]
						+ "-" + sqlMax0(a0Expr)
					)
				)
		break;
	case "DP":
		sSQL = IIF("a.hful<>0"
				, "a." + cDP
				, sqlMax(0
					, "a." + getV2_oVars["HDP" + cSuffix]
						+ "-" + sqlMax0("-" + a0Expr)
					)
				)
		break;
	case "TV":
		sSQL = IIF("a.hful<>0"
			, "- abs(a." + getV2_oVars["HTV" + cSuffix] + ")"
			, "-" + sqlMin( " abs(a." + getV2_oVars["HTV" + cSuffix] + ")"
				, sqlMax0(
					"-" + a0Expr
					)
				)
			)
		break;
	case "DV":
		sSQL = IIF("a.hful<>0"
			, "-abs(a." + getV2_oVars["HDV" + cSuffix]+")"
 			, "-" + sqlMin( " abs(a." + getV2_oVars["HDV" + cSuffix]+")"
				, sqlMax0(
					a0Expr
					)
				)
			)
		break;
	}
	return sqlRound(sSQL, 2);
}


function _sqlSumBookVar(cVar)
{
	var cTD = cVar.charAt(1);
	var cPV = cVar.charAt(2);
	var cSuffix = cVar.substr(3);
	
	cTP = getV2_oVars["HTP" + cSuffix]
	cTV = getV2_oVars["HTV" + cSuffix]
	cDP = getV2_oVars["HDP" + cSuffix]
	cDV = getV2_oVars["HDV" + cSuffix]
	
	switch(cTD + cPV)
	{
	case "TP":
		sSQL = 
			sqlMax0(
				"a." + cTP
					+ "-" + sqlMax(0
						, " sum(b." + cDP
								+ "-abs(b." + cDV + ")"
								+ "-b." + cTP
								+ "+abs(b." + cTV + ")"
							+ ")"
						)
				)
				+ " AS b0TP" + cSuffix
		break;
	case "DP":
		sSQL = 
			sqlMax0(
				"a." + cDP
					+ "-" + sqlMax(0
						, " sum(b." + cTP
								+ "-abs(b." + cTV + ")"
								+ "-b." + cDP
								+ "+abs(b." + cDV + ")"
							+ ")"
						)
				)
				+ " AS b0DP" + cSuffix
		break;
	case "TV":
		sSQL = 
			// -MIN(-V0HTV~,MAX(0,(S0HTP~+S0HTV~)-(S0HDP~+S0HDV~)))
 			"-" + sqlMin(
 				"abs(a." + cTV + ")"
				, sqlMax(0
					, " sum(b." + cTP
							+ "-abs(b." + cTV + ")"
							+ "-b." + cDP
							+ "+abs(b." + cDV + ")"
						+ ")"
					)
				)
				+ " AS b0TV" + cSuffix;
		break;
	case "DV":
		sSQL = 
			 // MIN(V0HDV~,MAX(0,(S0HDP~+S0HDV~)-(S0HTP~+S0HTV~)))
 			"-" + sqlMin(
 				"abs(a." + cDV + ")"
				, sqlMax(0
					, " sum(b." + cDP
							+ "-abs(b." + cDV + ")"
							+ "-b." + cTP
							+ "+abs(b." + cTV + ")"
						+ ")"
					)
				)
				+ " AS b0DV" + cSuffix
		break;
	}
	return sSQL;
}

function jrvar(cVar, jrno)
{
	return jr_(jrno, cVar);
}

function jrv(sExpr)
{
	return jr_value(this.getTable().getValue("hreg"), sExpr, this.getTable());
}

function sumreg(reg, expr, filter)
{
	var fdoc;
	var fid_doc;
	
	if (this.getJDoc() != null)
	{
		fdoc = this.getJDoc().getVar("HDOC");
		fid_doc = this.getJDoc().getObjectID();
	}
	else
	{
		fdoc = this.getTable().getValue("fdoc"),
		fid_doc = this.getTable().getValue("fwid");
	}
	
	var sum = 0;	
	reg = this.eval(reg);  // номер журнала регистрации передается выражением
	reg = String(reg);
	var oReg = getJournal(reg); 
	if (!oReg)
		return null;
//-	var tblDocReg = OpenTable("s", "docreg", "docid") // fid_doc,freg
	var oSnap = getSnap(" SELECT hiddeal,fwid,hdat,hid_doc"
   					  + " FROM " + oReg.getFullTableName()
					  + " WHERE HID_DOC=" + sqlTo(fid_doc)
					  + " AND HREG=" + sqlTo(oReg.Num)
					  + " ORDER BY HID_DOC,HREG");
	if(oSnap == null)
	{
		WAIT("У документа нет схем регистрации");
	}
	else
	{
		var fiddeal = oSnap[0];
		var fwid = oSnap[1];
		var hdat = oSnap[2];
		var hid_doc = oSnap[3];
		
		var aSum = getSnap(s=
		    "SELECT SUM("+expr+")"
		    + " FROM ^" + getRegTblForJid(reg)
			+ " WHERE HIDDEAL=" + sqlTo(fiddeal)
				+ (filter? " AND " + filter: "")
				+ " AND (" + sqlCmpVectors("<", "hdat", sqlTo(hdat), "fwid", sqlTo(fwid)) + ")"
			);
			
		sum = aSum[0];
	}
	return sum;
}

// Функция возвращает вид журнала регитрации по номеру
function jrvid(jID)
{
	if (getJournal(jID) == null)
		return "";
	return (strIn("P",getJournal(jID).getType())?"+":"-");
}
/*
var getCl_reg_tbl;
function getCl_reg()
{
	if(!getCl_reg_tbl)
		getCl_reg_tbl = OpenTable("s", "cl_reg", "cl_reg");
	return getCl_reg_tbl;
}
*/
function sqlMax0(sqlExpr)
{
	return sqlIIF("0<" + sqlExpr,sqlExpr,0);
}

function reg_ob(reg, expr, dat1, dat2)
{
	var tblDocReg = OpenTable("s"
		, "SELECT SUM(" + expr + ") as FRET "
		+ " FROM " + getRegTblForJid(reg)
		+ " WHERE Hreg=" + sqlTo(reg)
			+ " AND Hdat BETWEEN " + sqlTo(dat1)
				+ " AND " + sqlTo(dat2)
		);

	var nSum = 0;
	if (!tblDocReg.isEmpty())
		nSum = Number(tblDocReg.getValue("FRET"));
	
	tblDocReg.close();
	return nSum;
}

function mdocreg_ob(expr, cond)
{
	var tblDocReg = getSnap("SELECT sum(" + expr + ") AS res"
		+ " FROM ^mdocreg"
		+ " WHERE " + cond
		);
	if(tblDocReg)
		return tblDocReg[0];
	else
		return 0;
}

function reg_ob2(reg, expr, dat1, dat2)
{
	var tblDocReg = OpenTable("s"
		, "SELECT *"
		+ " FROM " + getRegTblForJid(reg)
		+ " WHERE Hreg=" + sqlTo(reg)
			+ " AND Hdat BETWEEN " + sqlTo(dat1)
				+ " AND " + sqlTo(dat2)
		);

	var nSum = 0;
	var oEval = new DpEval();
	oEval.setTable(tblDocReg);
	for(; !tblDocReg.IsEOF(); tblDocReg.MoveNext())
	{
		nSum += Number(oEval.eval(expr));
	}
	
	tblDocReg.close();
	return nSum;
}

var oRegXpRegistratorObject;

function getRegistrator()
{
	if (!oRegXpRegistratorObject)
		oRegXpRegistratorObject = new DpJRegistrator("",0,"S");
	return oRegXpRegistratorObject;
}

function getJournal(jID)
{
	if (getRegistrator().listJournals()[jID])
		return getRegistrator().listJournals()[jID];
	if (getRegistrator().listJournals()["S" + Number(jID)])
		return getRegistrator().listJournals()["S" + Number(jID)];
	if (getRegistrator().listJournals()["S" + Number(jID) + "_DEC"])
		return getRegistrator().listJournals()["S" + Number(jID) + "_DEC"];		
	return null;
}

function getRegTblForJid(jID)
{
	if (getJournal(jID) != null)
		return getJournal(jID).getFullTableName();
	return null;
}